
#property copyright "Andrew Opeyda [ njel ]  2010, AISignals."
#property link      "http://www.aiSignals.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1 Red
#property indicator_color2 Gray
#property indicator_color3 DeepPink
#property indicator_color4 Peru
#property indicator_color5 BlueViolet
#property indicator_color6 DeepPink
#property indicator_color7 MediumTurquoise
#property indicator_color8 Crimson

int g_count_76 = 0;
string gs_obj_80 = "obj";
double g_ibuf_88[];
double g_ibuf_92[];
double g_ibuf_96[];
double g_ibuf_100[];
double g_ibuf_104[];
double g_ibuf_108[];
double g_ibuf_112[];
extern double Threshold = 0.8;
extern int nobs = 500;
extern int FiltPer = 8;
double gda_132[170];
double gda_136[170];
double gda_140[170];
string gsa_144[170];
double gda_148[170];
string gs_bat_152 = "Bat";
string gs_crab_160 = "Crab";
string gs_gartley_168 = "Gartley";
string gs_176 = "Butterfly";
double gda_184[10000];
int gia_188[10000];
double gda_192[10000];
double gda_unused_196[10000];
int g_index_200 = 0;
double g_ibuf_204[];
double gd_208;

string Gfx.NewObjectName() {
   string ls_ret_0 = gs_obj_80 + "-" + g_count_76;
   g_count_76++;
   return (ls_ret_0);
}

void Gfx.Clear() {
   for (int l_count_0 = 0; l_count_0 < g_count_76; l_count_0++) ObjectDelete(gs_obj_80 + "-" + l_count_0);
   g_count_76 = 0;
}

void Gfx.LabelObjectCalendar(int a_x_0, int a_y_4, string a_text_8 = "epmty", color a_color_16 = 42495, int a_fontsize_20 = 10, int a_window_24 = 0, int a_corner_28 = 0, string a_fontname_32 = "Arial") {
   string l_name_40 = Gfx.NewObjectName();
   ObjectCreate(l_name_40, OBJ_LABEL, a_window_24, 0, 0, 0, 0);
   ObjectSetText(l_name_40, a_text_8, a_fontsize_20, a_fontname_32, a_color_16);
   ObjectSet(l_name_40, OBJPROP_CORNER, a_corner_28);
   ObjectSet(l_name_40, OBJPROP_XDISTANCE, a_x_0);
   ObjectSet(l_name_40, OBJPROP_YDISTANCE, a_y_4);
}

void Gfx.LabelObject(int a_x_0, int a_y_4, string a_text_8 = "epmty", color a_color_16 = 42495, int a_fontsize_20 = 10, int a_window_24 = 0, int a_corner_28 = 0, bool ai_32 = TRUE) {
   int li_36 = -1;
   if (a_corner_28 == 3) li_36 = 1;
   string l_name_40 = Gfx.NewObjectName();
   if (ai_32) {
      ObjectCreate(l_name_40, OBJ_LABEL, a_window_24, 0, 0, 0, 0);
      ObjectSetText(l_name_40, a_text_8, a_fontsize_20, "Arial Black", Black);
      ObjectSet(l_name_40, OBJPROP_CORNER, a_corner_28);
      ObjectSet(l_name_40, OBJPROP_XDISTANCE, a_x_0);
      ObjectSet(l_name_40, OBJPROP_YDISTANCE, a_y_4);
      l_name_40 = Gfx.NewObjectName();
   }
   ObjectCreate(l_name_40, OBJ_LABEL, a_window_24, 0, 0, 0, 0);
   ObjectSetText(l_name_40, a_text_8, a_fontsize_20, "Arial Black", a_color_16);
   ObjectSet(l_name_40, OBJPROP_CORNER, a_corner_28);
   ObjectSet(l_name_40, OBJPROP_XDISTANCE, a_x_0 + li_36);
   ObjectSet(l_name_40, OBJPROP_YDISTANCE, a_y_4 + li_36);
}

void Gfx.TextObject(int a_datetime_0, double a_price_4, string a_text_12 = "epmty", color a_color_20 = 42495, int a_fontsize_24 = 10, int a_angle_28 = 0, int a_window_32 = 0) {
   string l_name_36 = Gfx.NewObjectName();
   ObjectCreate(l_name_36, OBJ_TEXT, a_window_32, a_datetime_0, a_price_4, 0, 0);
   ObjectSetText(l_name_36, a_text_12, a_fontsize_24, "Arial", a_color_20);
   ObjectSet(l_name_36, OBJPROP_ANGLE, a_angle_28);
}

void Gfx.ChartObjectLine(int a_datetime_0, int a_datetime_4, double a_price_8, double a_price_16, color a_color_24 = 42495, int a_width_28 = 3, int a_window_32 = 0) {
   string l_name_36 = Gfx.NewObjectName();
   ObjectCreate(l_name_36, OBJ_TREND, a_window_32, a_datetime_0, a_price_8, a_datetime_4, a_price_16);
   ObjectSet(l_name_36, OBJPROP_WIDTH, a_width_28);
   ObjectSet(l_name_36, OBJPROP_RAY, FALSE);
   ObjectSet(l_name_36, OBJPROP_COLOR, a_color_24);
}

int deinit() {
   Gfx.Clear();
   Print("deinit =)");
   return (0);
}

int init() {
   Gfx.Clear();
   gd_208 = 0.0625 / MathPow(MathSin(3.1415926536 / FiltPer), 4);
   SetIndexBuffer(0, g_ibuf_204);
   SetIndexStyle(0, DRAW_NONE, STYLE_DOT);
   int li_0 = 167;
   SetIndexStyle(1, DRAW_NONE, STYLE_SOLID, 1);
   SetIndexBuffer(1, g_ibuf_88);
   SetIndexStyle(2, DRAW_NONE, STYLE_SOLID, 2);
   SetIndexBuffer(2, g_ibuf_92);
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexBuffer(3, g_ibuf_96);
   SetIndexArrow(3, li_0);
   SetIndexStyle(4, DRAW_ARROW);
   SetIndexBuffer(4, g_ibuf_100);
   SetIndexArrow(4, li_0);
   SetIndexStyle(5, DRAW_ARROW);
   SetIndexBuffer(5, g_ibuf_104);
   SetIndexArrow(5, li_0);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6, g_ibuf_108);
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7, g_ibuf_112);
   InitValues();
   return (0);
}

int start() {
   double lda_0[];
   string ls_28;
   int li_36;
   double ld_40;
   double ld_48;
   double ld_56;
   int li_64;
   double l_istddev_68;
   double ld_76;
   int li_84;
   double ld_96;
   double ld_104;
   double ld_112;
   double ld_120;
   string ls_128;
   ArrayResize(lda_0, nobs);
   for (int l_index_4 = 0; l_index_4 < nobs; l_index_4++) lda_0[l_index_4] = Price(l_index_4);
   HPF(nobs, gd_208, lda_0, g_ibuf_204);
   ZZ();
   for (l_index_4 = 0; l_index_4 < 170; l_index_4++) gda_192[l_index_4] = (gda_184[l_index_4] - (gda_184[l_index_4 + 1])) / Point;
   string ls_8 = "";
   double ld_unused_16 = 0;
   ArrayInitialize(g_ibuf_88, EMPTY_VALUE);
   ArrayInitialize(g_ibuf_92, EMPTY_VALUE);
   Gfx.Clear();
   bool li_24 = TRUE;
   for (l_index_4 = 0; l_index_4 < 50; l_index_4++) {
      if (gda_192[l_index_4 + 0] != 0.0) {
         if (gda_192[l_index_4 + 1] != 0.0) {
            if (gda_192[l_index_4 + 2] != 0.0) {
               if (gda_192[l_index_4 + 3] != 0.0) {
                  ls_28 = "NA";
                  li_36 = 15570276;
                  if (gda_192[l_index_4 + 0] > 0.0) {
                     ls_28 = "Bearish";
                     li_36 = 255;
                  }
                  if (gda_192[l_index_4 + 0] < 0.0) ls_28 = "Bullish";
                  ld_40 = -(gda_192[l_index_4 + 2]) / (gda_192[l_index_4 + 3]);
                  ld_48 = -(gda_192[l_index_4 + 1]) / (gda_192[l_index_4 + 2]);
                  ld_56 = -(gda_192[l_index_4 + 0]) / (gda_192[l_index_4 + 1]);
                  ls_8 = ls_8 + "|   " + DoubleToStr(ld_40, 3) + "    |    " + DoubleToStr(ld_48, 3) + "   |    " + DoubleToStr(ld_56, 3) + "    |    ";
                  li_64 = Check(ld_40, ld_48, ld_56);
                  if (gda_148[li_64] <= Threshold) {
                     ls_8 = ls_8 + gsa_144[li_64] + " " + ls_28 + "  #" + li_64;
                     g_ibuf_92[gia_188[l_index_4 + 0]] = gda_184[l_index_4 + 0];
                     g_ibuf_92[gia_188[l_index_4 + 1]] = gda_184[l_index_4 + 1];
                     g_ibuf_92[gia_188[l_index_4 + 2]] = gda_184[l_index_4 + 2];
                     g_ibuf_92[gia_188[l_index_4 + 3]] = gda_184[l_index_4 + 3];
                     g_ibuf_92[gia_188[l_index_4 + 4]] = gda_184[l_index_4 + 4];
                     l_istddev_68 = iStdDev(NULL, 0, 10, 0, MODE_EMA, PRICE_CLOSE, gia_188[l_index_4 + 0]);
                     if (gda_192[l_index_4 + 0] > 0.0) {
                        Gfx.TextObject(Time[gia_188[l_index_4 + 0]], gda_184[l_index_4 + 0] + 2.0 * l_istddev_68, "D", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 1]], gda_184[l_index_4 + 1] - 0.0 * l_istddev_68, "C", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 2]], gda_184[l_index_4 + 2] + 2.0 * l_istddev_68, "B", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 3]], gda_184[l_index_4 + 3] - 0.0 * l_istddev_68, "A", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 4]], gda_184[l_index_4 + 4] + 2.0 * l_istddev_68, "X", Black, 10, 0, 0);
                     } else {
                        Gfx.TextObject(Time[gia_188[l_index_4 + 0]], gda_184[l_index_4 + 0] - 0.0 * l_istddev_68, "D", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 1]], gda_184[l_index_4 + 1] + 2.0 * l_istddev_68, "C", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 2]], gda_184[l_index_4 + 2] - 0.0 * l_istddev_68, "B", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 3]], gda_184[l_index_4 + 3] + 2.0 * l_istddev_68, "A", Black, 10, 0, 0);
                        Gfx.TextObject(Time[gia_188[l_index_4 + 4]], gda_184[l_index_4 + 4] - 0.0 * l_istddev_68, "X", Black, 10, 0, 0);
                     }
                     Gfx.ChartObjectLine(Time[gia_188[l_index_4 + 0]], Time[gia_188[l_index_4 + 1]], gda_184[l_index_4 + 0], gda_184[l_index_4 + 1], li_36, 3);
                     Gfx.ChartObjectLine(Time[gia_188[l_index_4 + 1]], Time[gia_188[l_index_4 + 2]], gda_184[l_index_4 + 1], gda_184[l_index_4 + 2], li_36, 3);
                     Gfx.ChartObjectLine(Time[gia_188[l_index_4 + 2]], Time[gia_188[l_index_4 + 3]], gda_184[l_index_4 + 2], gda_184[l_index_4 + 3], li_36, 3);
                     Gfx.ChartObjectLine(Time[gia_188[l_index_4 + 3]], Time[gia_188[l_index_4 + 4]], gda_184[l_index_4 + 3], gda_184[l_index_4 + 4], li_36, 3);
                     if (li_24 == TRUE) {
                        ld_76 = 1 - MathMin(1.0 * gda_148[li_64], 1);
                        li_24 = FALSE;
                        Gfx.LabelObject(10, 20, TimeToStr(Time[gia_188[l_index_4]]), DarkBlue, 10, 0, 0, 0);
                        Gfx.LabelObject(10, 40, gsa_144[li_64] + " " + ls_28, li_36, 10, 0, 0, 0);
                        li_84 = 255;
                        for (int l_count_88 = 0; l_count_88 < 5; l_count_88++) {
                           switch (l_count_88) {
                           case 0:
                              li_84 = 55295;
                              break;
                           case 1:
                              li_84 = 42495;
                              break;
                           case 2:
                              li_84 = 36095;
                              break;
                           case 3:
                              li_84 = 17919;
                              break;
                           case 4:
                              li_84 = 255;
                           }
                           if (l_count_88 > 10.0 * ld_76) li_84 = 8421504;
                           Gfx.LabelObjectCalendar(20 * l_count_88 + 10, 55, CharToStr(171), li_84, 20, 0, 0, "Wingdings");
                        }
                        ld_96 = gda_184[l_index_4 + 1];
                        ld_104 = gda_184[l_index_4];
                        ld_112 = ld_96 - ld_104;
                        ld_120 = gda_184[l_index_4] + 0.236 * ld_112;
                        ls_128 = "Buy";
                        if (gda_192[l_index_4 + 0] > 0.0) {
                           ld_104 = gda_184[l_index_4];
                           ld_96 = gda_184[l_index_4 + 1];
                           ld_112 = ld_104 - ld_96;
                           ld_120 = gda_184[l_index_4] - 0.236 * ld_112;
                           ls_128 = "Sell";
                        }
                        for (int l_count_136 = 0; l_count_136 < 10; l_count_136++) {
                           g_ibuf_96[gia_188[l_index_4] - l_count_136] = ld_104;
                           g_ibuf_100[gia_188[l_index_4] - l_count_136] = ld_96;
                           g_ibuf_104[gia_188[l_index_4] - l_count_136] = ld_120;
                        }
                        Gfx.LabelObject(10, 80, ls_128, li_36, 10, 0, 0, 0);
                        Gfx.LabelObject(10, 95, "Target", Green, 10, 0, 0, 0);
                        Gfx.LabelObject(10, 110, "StopLoss", Blue, 10, 0, 0, 0);
                        Gfx.LabelObject(100, 80, "" + DoubleToStr(ld_120, Digits), li_36, 10, 0, 0, 0);
                        Gfx.LabelObject(100, 95, "" + DoubleToStr(ld_96, Digits), Orange, 10, 0, 0, 0);
                        Gfx.LabelObject(100, 110, "" + DoubleToStr(ld_104, Digits), Orange, 10, 0, 0, 0);
                        GlobalVariableSet("ENTRY", ld_120);
                        GlobalVariableSet("TP", ld_96);
                        GlobalVariableSet("SL", ld_104);
                        GlobalVariableSet("Time", Time[gia_188[l_index_4]]);
                     }
                  }
               }
            }
         }
      }
   }
   return (0);
}

void ZZ() {
   int li_4;
   g_index_200 = 0;
   ArrayInitialize(g_ibuf_88, EMPTY_VALUE);
   g_ibuf_88[0] = Close[0];
   for (int l_index_0 = 0; l_index_0 < nobs; l_index_0++) {
      if (g_ibuf_204[l_index_0] >= g_ibuf_204[l_index_0 - 1] && g_ibuf_204[l_index_0] >= g_ibuf_204[l_index_0 + 1]) {
         li_4 = ArrayMaximum(High, 4, l_index_0 - 1);
         g_ibuf_88[l_index_0] = High[li_4];
         gda_184[g_index_200] = g_ibuf_88[l_index_0];
         gia_188[g_index_200] = l_index_0;
         g_index_200++;
      }
      if (g_ibuf_204[l_index_0] <= g_ibuf_204[l_index_0 - 1] && g_ibuf_204[l_index_0] <= g_ibuf_204[l_index_0 + 1]) {
         li_4 = ArrayMinimum(Low, 4, l_index_0 - 1);
         g_ibuf_88[l_index_0] = Low[li_4];
         gda_184[g_index_200] = g_ibuf_88[l_index_0];
         gia_188[g_index_200] = l_index_0;
         g_index_200++;
      }
   }
}

void HPF(int ai_0, double ad_4, double ada_12[], double &ada_16[]) {
   double lda_20[];
   double lda_24[];
   double lda_28[];
   double ld_32;
   double ld_40;
   double ld_48;
   double ld_56;
   double ld_64;
   double ld_72;
   double ld_80;
   double ld_88;
   double ld_104;
   double ld_112;
   double ld_120;
   double ld_128;
   ArrayResize(lda_20, ai_0);
   ArrayResize(lda_24, ai_0);
   ArrayResize(lda_28, ai_0);
   lda_20[0] = ad_4 + 1.0;
   lda_24[0] = -2.0 * ad_4;
   lda_28[0] = ad_4;
   for (int l_index_136 = 1; l_index_136 < ai_0 - 2; l_index_136++) {
      lda_20[l_index_136] = 6.0 * ad_4 + 1.0;
      lda_24[l_index_136] = -4.0 * ad_4;
      lda_28[l_index_136] = ad_4;
   }
   lda_20[1] = 5.0 * ad_4 + 1.0;
   lda_20[ai_0 - 1] = ad_4 + 1.0;
   lda_20[ai_0 - 2] = 5.0 * ad_4 + 1.0;
   lda_24[ai_0 - 2] = -2.0 * ad_4;
   lda_24[ai_0 - 1] = 0.0;
   lda_28[ai_0 - 2] = 0.0;
   lda_28[ai_0 - 1] = 0.0;
   for (l_index_136 = 0; l_index_136 < ai_0; l_index_136++) {
      ld_128 = lda_20[l_index_136] - ld_56 * ld_32 - ld_104 * ld_80;
      ld_112 = lda_24[l_index_136];
      ld_72 = ld_32;
      ld_32 = (ld_112 - ld_56 * ld_40) / ld_128;
      lda_24[l_index_136] = ld_32;
      ld_120 = lda_28[l_index_136];
      ld_80 = ld_40;
      ld_40 = ld_120 / ld_128;
      lda_28[l_index_136] = ld_40;
      lda_20[l_index_136] = (ada_12[l_index_136] - ld_88 * ld_104 - ld_48 * ld_56) / ld_128;
      ld_88 = ld_48;
      ld_48 = lda_20[l_index_136];
      ld_56 = ld_112 - ld_64 * ld_72;
      ld_104 = ld_64;
      ld_64 = ld_120;
   }
   ld_40 = 0;
   ld_32 = lda_20[ai_0 - 1];
   ada_16[ai_0 - 1] = ld_32;
   for (l_index_136 = ai_0 - 2; l_index_136 >= 0; l_index_136--) {
      ada_16[l_index_136] = lda_20[l_index_136] - lda_24[l_index_136] * ld_32 - lda_28[l_index_136] * ld_40;
      ld_40 = ld_32;
      ld_32 = ada_16[l_index_136];
   }
}

double Price(int ai_0) {
   double ld_ret_4 = (High[ai_0] + Low[ai_0]) / 2.0;
   return (ld_ret_4);
}

void InitValues() {
   gda_132[0] = 0.382;
   gda_136[0] = 0.382;
   gda_140[0] = 2.618;
   gsa_144[0] = gs_bat_152;
   gda_132[1] = 0.382;
   gda_136[1] = 0.447;
   gda_140[1] = 2.618;
   gsa_144[1] = gs_bat_152;
   gda_132[2] = 0.382;
   gda_136[2] = 0.5;
   gda_140[2] = 2.618;
   gsa_144[2] = gs_bat_152;
   gda_132[3] = 0.382;
   gda_136[3] = 0.618;
   gda_140[3] = 2.618;
   gsa_144[3] = gs_bat_152;
   gda_132[4] = 0.382;
   gda_136[4] = 0.707;
   gda_140[4] = 2.24;
   gsa_144[4] = gs_bat_152;
   gda_132[5] = 0.382;
   gda_136[5] = 0.707;
   gda_140[5] = 2.618;
   gsa_144[5] = gs_bat_152;
   gda_132[6] = 0.382;
   gda_136[6] = 0.786;
   gda_140[6] = 2.24;
   gsa_144[6] = gs_bat_152;
   gda_132[7] = 0.382;
   gda_136[7] = 0.786;
   gda_140[7] = 2.618;
   gsa_144[7] = gs_bat_152;
   gda_132[8] = 0.382;
   gda_136[8] = 0.886;
   gda_140[8] = 2.0;
   gsa_144[8] = gs_bat_152;
   gda_132[9] = 0.382;
   gda_136[9] = 0.886;
   gda_140[9] = 2.24;
   gsa_144[9] = gs_bat_152;
   gda_132[10] = 0.382;
   gda_136[10] = 0.886;
   gda_140[10] = 2.618;
   gsa_144[10] = gs_bat_152;
   gda_132[11] = 0.5;
   gda_136[11] = 0.382;
   gda_140[11] = 2.24;
   gsa_144[11] = gs_bat_152;
   gda_132[12] = 0.5;
   gda_136[12] = 0.382;
   gda_140[12] = 2.618;
   gsa_144[12] = gs_bat_152;
   gda_132[13] = 0.5;
   gda_136[13] = 0.447;
   gda_140[13] = 2.24;
   gsa_144[13] = gs_bat_152;
   gda_132[14] = 0.5;
   gda_136[14] = 0.447;
   gda_140[14] = 2.618;
   gsa_144[14] = gs_bat_152;
   gda_132[15] = 0.5;
   gda_136[15] = 0.5;
   gda_140[15] = 2.0;
   gsa_144[15] = gs_bat_152;
   gda_132[16] = 0.5;
   gda_136[16] = 0.5;
   gda_140[16] = 2.24;
   gsa_144[16] = gs_bat_152;
   gda_132[17] = 0.5;
   gda_136[17] = 0.5;
   gda_140[17] = 2.618;
   gsa_144[17] = gs_bat_152;
   gda_132[18] = 0.5;
   gda_136[18] = 0.618;
   gda_140[18] = 1.618;
   gsa_144[18] = gs_bat_152;
   gda_132[19] = 0.5;
   gda_136[19] = 0.618;
   gda_140[19] = 2.0;
   gsa_144[19] = gs_bat_152;
   gda_132[20] = 0.5;
   gda_136[20] = 0.618;
   gda_140[20] = 2.24;
   gsa_144[20] = gs_bat_152;
   gda_132[21] = 0.5;
   gda_136[21] = 0.618;
   gda_140[21] = 2.618;
   gsa_144[21] = gs_bat_152;
   gda_132[22] = 0.5;
   gda_136[22] = 0.707;
   gda_140[22] = 1.618;
   gsa_144[22] = gs_bat_152;
   gda_132[23] = 0.5;
   gda_136[23] = 0.707;
   gda_140[23] = 2.0;
   gsa_144[23] = gs_bat_152;
   gda_132[24] = 0.5;
   gda_136[24] = 0.707;
   gda_140[24] = 2.24;
   gsa_144[24] = gs_bat_152;
   gda_132[25] = 0.5;
   gda_136[25] = 0.707;
   gda_140[25] = 2.618;
   gsa_144[25] = gs_bat_152;
   gda_132[26] = 0.5;
   gda_136[26] = 0.786;
   gda_140[26] = 1.618;
   gsa_144[26] = gs_bat_152;
   gda_132[27] = 0.5;
   gda_136[27] = 0.786;
   gda_140[27] = 2.0;
   gsa_144[27] = gs_bat_152;
   gda_132[28] = 0.5;
   gda_136[28] = 0.786;
   gda_140[28] = 2.24;
   gsa_144[28] = gs_bat_152;
   gda_132[29] = 0.5;
   gda_136[29] = 0.786;
   gda_140[29] = 2.618;
   gsa_144[29] = gs_bat_152;
   gda_132[30] = 0.5;
   gda_136[30] = 0.886;
   gda_140[30] = 1.618;
   gsa_144[30] = gs_bat_152;
   gda_132[31] = 0.5;
   gda_136[31] = 0.886;
   gda_140[31] = 2.0;
   gsa_144[31] = gs_bat_152;
   gda_132[32] = 0.5;
   gda_136[32] = 0.886;
   gda_140[32] = 2.24;
   gsa_144[32] = gs_bat_152;
   gda_132[33] = 0.5;
   gda_136[33] = 0.886;
   gda_140[33] = 2.618;
   gsa_144[33] = gs_bat_152;
   gda_132[34] = 0.382;
   gda_136[34] = 0.382;
   gda_140[34] = 1.618;
   gsa_144[34] = gs_crab_160;
   gda_132[35] = 0.382;
   gda_136[35] = 0.382;
   gda_140[35] = 2.0;
   gsa_144[35] = gs_crab_160;
   gda_132[36] = 0.382;
   gda_136[36] = 0.382;
   gda_140[36] = 2.24;
   gsa_144[36] = gs_crab_160;
   gda_132[37] = 0.382;
   gda_136[37] = 0.382;
   gda_140[37] = 2.618;
   gsa_144[37] = gs_crab_160;
   gda_132[38] = 0.382;
   gda_136[38] = 0.382;
   gda_140[38] = 3.14;
   gsa_144[38] = gs_crab_160;
   gda_132[39] = 0.382;
   gda_136[39] = 0.382;
   gda_140[39] = 3.618;
   gsa_144[39] = gs_crab_160;
   gda_132[40] = 0.382;
   gda_136[40] = 0.447;
   gda_140[40] = 1.618;
   gsa_144[40] = gs_crab_160;
   gda_132[41] = 0.382;
   gda_136[41] = 0.447;
   gda_140[41] = 2.0;
   gsa_144[41] = gs_crab_160;
   gda_132[42] = 0.382;
   gda_136[42] = 0.447;
   gda_140[42] = 2.24;
   gsa_144[42] = gs_crab_160;
   gda_132[43] = 0.382;
   gda_136[43] = 0.447;
   gda_140[43] = 2.618;
   gsa_144[43] = gs_crab_160;
   gda_132[44] = 0.382;
   gda_136[44] = 0.447;
   gda_140[44] = 3.14;
   gsa_144[44] = gs_crab_160;
   gda_132[45] = 0.382;
   gda_136[45] = 0.447;
   gda_140[45] = 3.618;
   gsa_144[45] = gs_crab_160;
   gda_132[46] = 0.382;
   gda_136[46] = 0.5;
   gda_140[46] = 1.618;
   gsa_144[46] = gs_crab_160;
   gda_132[47] = 0.382;
   gda_136[47] = 0.5;
   gda_140[47] = 2.0;
   gsa_144[47] = gs_crab_160;
   gda_132[48] = 0.382;
   gda_136[48] = 0.5;
   gda_140[48] = 2.24;
   gsa_144[48] = gs_crab_160;
   gda_132[49] = 0.382;
   gda_136[49] = 0.5;
   gda_140[49] = 2.618;
   gsa_144[49] = gs_crab_160;
   gda_132[50] = 0.382;
   gda_136[50] = 0.5;
   gda_140[50] = 3.14;
   gsa_144[50] = gs_crab_160;
   gda_132[51] = 0.382;
   gda_136[51] = 0.5;
   gda_140[51] = 3.618;
   gsa_144[51] = gs_crab_160;
   gda_132[52] = 0.382;
   gda_136[52] = 0.618;
   gda_140[52] = 1.618;
   gsa_144[52] = gs_crab_160;
   gda_132[53] = 0.382;
   gda_136[53] = 0.618;
   gda_140[53] = 2.0;
   gsa_144[53] = gs_crab_160;
   gda_132[54] = 0.382;
   gda_136[54] = 0.618;
   gda_140[54] = 2.24;
   gsa_144[54] = gs_crab_160;
   gda_132[55] = 0.382;
   gda_136[55] = 0.618;
   gda_140[55] = 2.618;
   gsa_144[55] = gs_crab_160;
   gda_132[56] = 0.382;
   gda_136[56] = 0.618;
   gda_140[56] = 3.14;
   gsa_144[56] = gs_crab_160;
   gda_132[57] = 0.382;
   gda_136[57] = 0.618;
   gda_140[57] = 3.618;
   gsa_144[57] = gs_crab_160;
   gda_132[58] = 0.382;
   gda_136[58] = 0.707;
   gda_140[58] = 1.618;
   gsa_144[58] = gs_crab_160;
   gda_132[59] = 0.382;
   gda_136[59] = 0.707;
   gda_140[59] = 2.0;
   gsa_144[59] = gs_crab_160;
   gda_132[60] = 0.382;
   gda_136[60] = 0.707;
   gda_140[60] = 2.24;
   gsa_144[60] = gs_crab_160;
   gda_132[61] = 0.382;
   gda_136[61] = 0.707;
   gda_140[61] = 2.618;
   gsa_144[61] = gs_crab_160;
   gda_132[62] = 0.382;
   gda_136[62] = 0.707;
   gda_140[62] = 3.14;
   gsa_144[62] = gs_crab_160;
   gda_132[63] = 0.382;
   gda_136[63] = 0.707;
   gda_140[63] = 3.618;
   gsa_144[63] = gs_crab_160;
   gda_132[64] = 0.382;
   gda_136[64] = 0.786;
   gda_140[64] = 1.618;
   gsa_144[64] = gs_crab_160;
   gda_132[65] = 0.382;
   gda_136[65] = 0.786;
   gda_140[65] = 2.0;
   gsa_144[65] = gs_crab_160;
   gda_132[66] = 0.382;
   gda_136[66] = 0.786;
   gda_140[66] = 2.24;
   gsa_144[66] = gs_crab_160;
   gda_132[67] = 0.382;
   gda_136[67] = 0.786;
   gda_140[67] = 2.618;
   gsa_144[67] = gs_crab_160;
   gda_132[68] = 0.382;
   gda_136[68] = 0.786;
   gda_140[68] = 3.14;
   gsa_144[68] = gs_crab_160;
   gda_132[69] = 0.382;
   gda_136[69] = 0.786;
   gda_140[69] = 3.618;
   gsa_144[69] = gs_crab_160;
   gda_132[70] = 0.382;
   gda_136[70] = 0.886;
   gda_140[70] = 1.618;
   gsa_144[70] = gs_crab_160;
   gda_132[71] = 0.382;
   gda_136[71] = 0.886;
   gda_140[71] = 2.0;
   gsa_144[71] = gs_crab_160;
   gda_132[72] = 0.382;
   gda_136[72] = 0.886;
   gda_140[72] = 2.24;
   gsa_144[72] = gs_crab_160;
   gda_132[73] = 0.382;
   gda_136[73] = 0.886;
   gda_140[73] = 2.618;
   gsa_144[73] = gs_crab_160;
   gda_132[74] = 0.382;
   gda_136[74] = 0.886;
   gda_140[74] = 3.14;
   gsa_144[74] = gs_crab_160;
   gda_132[75] = 0.382;
   gda_136[75] = 0.886;
   gda_140[75] = 3.618;
   gsa_144[75] = gs_crab_160;
   gda_132[76] = 0.447;
   gda_136[76] = 0.382;
   gda_140[76] = 1.618;
   gsa_144[76] = gs_crab_160;
   gda_132[77] = 0.447;
   gda_136[77] = 0.382;
   gda_140[77] = 2.0;
   gsa_144[77] = gs_crab_160;
   gda_132[78] = 0.447;
   gda_136[78] = 0.382;
   gda_140[78] = 2.24;
   gsa_144[78] = gs_crab_160;
   gda_132[79] = 0.447;
   gda_136[79] = 0.382;
   gda_140[79] = 2.618;
   gsa_144[79] = gs_crab_160;
   gda_132[80] = 0.447;
   gda_136[80] = 0.382;
   gda_140[80] = 3.14;
   gsa_144[80] = gs_crab_160;
   gda_132[81] = 0.447;
   gda_136[81] = 0.382;
   gda_140[81] = 3.618;
   gsa_144[81] = gs_crab_160;
   gda_132[82] = 0.447;
   gda_136[82] = 0.447;
   gda_140[82] = 1.618;
   gsa_144[82] = gs_crab_160;
   gda_132[83] = 0.447;
   gda_136[83] = 0.447;
   gda_140[83] = 2.0;
   gsa_144[83] = gs_crab_160;
   gda_132[84] = 0.447;
   gda_136[84] = 0.447;
   gda_140[84] = 2.24;
   gsa_144[84] = gs_crab_160;
   gda_132[85] = 0.447;
   gda_136[85] = 0.707;
   gda_140[85] = 2.24;
   gsa_144[85] = gs_crab_160;
   gda_132[86] = 0.5;
   gda_136[86] = 0.382;
   gda_140[86] = 3.618;
   gsa_144[86] = gs_crab_160;
   gda_132[87] = 0.5;
   gda_136[87] = 0.447;
   gda_140[87] = 3.618;
   gsa_144[87] = gs_crab_160;
   gda_132[88] = 0.5;
   gda_136[88] = 0.5;
   gda_140[88] = 3.618;
   gsa_144[88] = gs_crab_160;
   gda_132[89] = 0.5;
   gda_136[89] = 0.618;
   gda_140[89] = 3.618;
   gsa_144[89] = gs_crab_160;
   gda_132[90] = 0.5;
   gda_136[90] = 0.707;
   gda_140[90] = 3.618;
   gsa_144[90] = gs_crab_160;
   gda_132[91] = 0.5;
   gda_136[91] = 0.786;
   gda_140[91] = 3.14;
   gsa_144[91] = gs_crab_160;
   gda_132[92] = 0.5;
   gda_136[92] = 0.786;
   gda_140[92] = 3.618;
   gsa_144[92] = gs_crab_160;
   gda_132[93] = 0.5;
   gda_136[93] = 0.886;
   gda_140[93] = 3.14;
   gsa_144[93] = gs_crab_160;
   gda_132[94] = 0.5;
   gda_136[94] = 0.886;
   gda_140[94] = 3.618;
   gsa_144[94] = gs_crab_160;
   gda_132[95] = 0.618;
   gda_136[95] = 0.382;
   gda_140[95] = 3.618;
   gsa_144[95] = gs_crab_160;
   gda_132[96] = 0.618;
   gda_136[96] = 0.447;
   gda_140[96] = 3.618;
   gsa_144[96] = gs_crab_160;
   gda_132[97] = 0.618;
   gda_136[97] = 0.5;
   gda_140[97] = 3.14;
   gsa_144[97] = gs_crab_160;
   gda_132[98] = 0.618;
   gda_136[98] = 0.5;
   gda_140[98] = 3.618;
   gsa_144[98] = gs_crab_160;
   gda_132[99] = 0.618;
   gda_136[99] = 0.618;
   gda_140[99] = 3.14;
   gsa_144[99] = gs_crab_160;
   gda_132[100] = 0.618;
   gda_136[100] = 0.618;
   gda_140[100] = 3.618;
   gsa_144[100] = gs_crab_160;
   gda_132[101] = 0.618;
   gda_136[101] = 0.707;
   gda_140[101] = 2.618;
   gsa_144[101] = gs_crab_160;
   gda_132[102] = 0.618;
   gda_136[102] = 0.707;
   gda_140[102] = 3.14;
   gsa_144[102] = gs_crab_160;
   gda_132[103] = 0.618;
   gda_136[103] = 0.707;
   gda_140[103] = 3.618;
   gsa_144[103] = gs_crab_160;
   gda_132[104] = 0.618;
   gda_136[104] = 0.786;
   gda_140[104] = 2.618;
   gsa_144[104] = gs_crab_160;
   gda_132[105] = 0.618;
   gda_136[105] = 0.786;
   gda_140[105] = 3.14;
   gsa_144[105] = gs_crab_160;
   gda_132[106] = 0.618;
   gda_136[106] = 0.786;
   gda_140[106] = 3.618;
   gsa_144[106] = gs_crab_160;
   gda_132[107] = 0.618;
   gda_136[107] = 0.886;
   gda_140[107] = 2.24;
   gsa_144[107] = gs_crab_160;
   gda_132[108] = 0.618;
   gda_136[108] = 0.886;
   gda_140[108] = 2.618;
   gsa_144[108] = gs_crab_160;
   gda_132[109] = 0.618;
   gda_136[109] = 0.886;
   gda_140[109] = 3.14;
   gsa_144[109] = gs_crab_160;
   gda_132[110] = 0.886;
   gda_136[110] = 0.382;
   gda_140[110] = 2.618;
   gsa_144[110] = gs_crab_160;
   gda_132[111] = 0.886;
   gda_136[111] = 0.382;
   gda_140[111] = 3.14;
   gsa_144[111] = gs_crab_160;
   gda_132[112] = 0.886;
   gda_136[112] = 0.382;
   gda_140[112] = 3.618;
   gsa_144[112] = gs_crab_160;
   gda_132[113] = 0.886;
   gda_136[113] = 0.447;
   gda_140[113] = 2.24;
   gsa_144[113] = gs_crab_160;
   gda_132[114] = 0.886;
   gda_136[114] = 0.447;
   gda_140[114] = 2.618;
   gsa_144[114] = gs_crab_160;
   gda_132[115] = 0.886;
   gda_136[115] = 0.447;
   gda_140[115] = 3.14;
   gsa_144[115] = gs_crab_160;
   gda_132[116] = 0.886;
   gda_136[116] = 0.5;
   gda_140[116] = 2.24;
   gsa_144[116] = gs_crab_160;
   gda_132[117] = 0.886;
   gda_136[117] = 0.5;
   gda_140[117] = 2.618;
   gsa_144[117] = gs_crab_160;
   gda_132[118] = 0.886;
   gda_136[118] = 0.618;
   gda_140[118] = 2.0;
   gsa_144[118] = gs_crab_160;
   gda_132[119] = 0.886;
   gda_136[119] = 0.618;
   gda_140[119] = 2.24;
   gsa_144[119] = gs_crab_160;
   gda_132[120] = 0.886;
   gda_136[120] = 0.618;
   gda_140[120] = 2.618;
   gsa_144[120] = gs_crab_160;
   gda_132[121] = 0.886;
   gda_136[121] = 0.707;
   gda_140[121] = 2.0;
   gsa_144[121] = gs_crab_160;
   gda_132[122] = 0.886;
   gda_136[122] = 0.707;
   gda_140[122] = 2.24;
   gsa_144[122] = gs_crab_160;
   gda_132[123] = 0.886;
   gda_136[123] = 0.786;
   gda_140[123] = 1.618;
   gsa_144[123] = gs_crab_160;
   gda_132[124] = 0.886;
   gda_136[124] = 0.786;
   gda_140[124] = 2.0;
   gsa_144[124] = gs_crab_160;
   gda_132[125] = 0.886;
   gda_136[125] = 0.786;
   gda_140[125] = 2.24;
   gsa_144[125] = gs_crab_160;
   gda_132[126] = 0.886;
   gda_136[126] = 0.886;
   gda_140[126] = 1.618;
   gsa_144[126] = gs_crab_160;
   gda_132[127] = 0.886;
   gda_136[127] = 0.886;
   gda_140[127] = 2.0;
   gsa_144[127] = gs_crab_160;
   gda_132[128] = 0.618;
   gda_136[128] = 0.382;
   gda_140[128] = 1.27;
   gsa_144[128] = gs_gartley_168;
   gda_132[129] = 0.618;
   gda_136[129] = 0.382;
   gda_140[129] = 1.414;
   gsa_144[129] = gs_gartley_168;
   gda_132[130] = 0.618;
   gda_136[130] = 0.382;
   gda_140[130] = 1.618;
   gsa_144[130] = gs_gartley_168;
   gda_132[131] = 0.618;
   gda_136[131] = 0.447;
   gda_140[131] = 1.27;
   gsa_144[131] = gs_gartley_168;
   gda_132[132] = 0.618;
   gda_136[132] = 0.447;
   gda_140[132] = 1.414;
   gsa_144[132] = gs_gartley_168;
   gda_132[133] = 0.618;
   gda_136[133] = 0.447;
   gda_140[133] = 1.618;
   gsa_144[133] = gs_gartley_168;
   gda_132[134] = 0.618;
   gda_136[134] = 0.5;
   gda_140[134] = 1.27;
   gsa_144[134] = gs_gartley_168;
   gda_132[135] = 0.618;
   gda_136[135] = 0.5;
   gda_140[135] = 1.414;
   gsa_144[135] = gs_gartley_168;
   gda_132[136] = 0.618;
   gda_136[136] = 0.5;
   gda_140[136] = 1.618;
   gsa_144[136] = gs_gartley_168;
   gda_132[137] = 0.618;
   gda_136[137] = 0.618;
   gda_140[137] = 1.27;
   gsa_144[137] = gs_gartley_168;
   gda_132[138] = 0.618;
   gda_136[138] = 0.618;
   gda_140[138] = 1.414;
   gsa_144[138] = gs_gartley_168;
   gda_132[139] = 0.618;
   gda_136[139] = 0.618;
   gda_140[139] = 1.618;
   gsa_144[139] = gs_gartley_168;
   gda_132[140] = 0.618;
   gda_136[140] = 0.707;
   gda_140[140] = 1.27;
   gsa_144[140] = gs_gartley_168;
   gda_132[141] = 0.618;
   gda_136[141] = 0.707;
   gda_140[141] = 1.414;
   gsa_144[141] = gs_gartley_168;
   gda_132[142] = 0.618;
   gda_136[142] = 0.707;
   gda_140[142] = 1.618;
   gsa_144[142] = gs_gartley_168;
   gda_132[143] = 0.618;
   gda_136[143] = 0.786;
   gda_140[143] = 1.27;
   gsa_144[143] = gs_gartley_168;
   gda_132[144] = 0.618;
   gda_136[144] = 0.786;
   gda_140[144] = 1.414;
   gsa_144[144] = gs_gartley_168;
   gda_132[145] = 0.618;
   gda_136[145] = 0.786;
   gda_140[145] = 1.618;
   gsa_144[145] = gs_gartley_168;
   gda_132[146] = 0.618;
   gda_136[146] = 0.886;
   gda_140[146] = 1.27;
   gsa_144[146] = gs_gartley_168;
   gda_132[147] = 0.618;
   gda_136[147] = 0.886;
   gda_140[147] = 1.414;
   gsa_144[147] = gs_gartley_168;
   gda_132[148] = 0.618;
   gda_136[148] = 0.886;
   gda_140[148] = 1.618;
   gsa_144[148] = gs_gartley_168;
   gda_132[149] = 0.786;
   gda_136[149] = 0.382;
   gda_140[149] = 1.618;
   gsa_144[149] = gs_176;
   gda_132[150] = 0.786;
   gda_136[150] = 0.382;
   gda_140[150] = 2.0;
   gsa_144[150] = gs_176;
   gda_132[151] = 0.786;
   gda_136[151] = 0.382;
   gda_140[151] = 2.24;
   gsa_144[151] = gs_176;
   gda_132[152] = 0.786;
   gda_136[152] = 0.447;
   gda_140[152] = 1.618;
   gsa_144[152] = gs_176;
   gda_132[153] = 0.786;
   gda_136[153] = 0.447;
   gda_140[153] = 2.0;
   gsa_144[153] = gs_176;
   gda_132[154] = 0.786;
   gda_136[154] = 0.447;
   gda_140[154] = 2.24;
   gsa_144[154] = gs_176;
   gda_132[155] = 0.786;
   gda_136[155] = 0.5;
   gda_140[155] = 1.618;
   gsa_144[155] = gs_176;
   gda_132[156] = 0.786;
   gda_136[156] = 0.5;
   gda_140[156] = 2.0;
   gsa_144[156] = gs_176;
   gda_132[157] = 0.786;
   gda_136[157] = 0.5;
   gda_140[157] = 2.24;
   gsa_144[157] = gs_176;
   gda_132[158] = 0.786;
   gda_136[158] = 0.618;
   gda_140[158] = 1.618;
   gsa_144[158] = gs_176;
   gda_132[159] = 0.786;
   gda_136[159] = 0.618;
   gda_140[159] = 2.0;
   gsa_144[159] = gs_176;
   gda_132[160] = 0.786;
   gda_136[160] = 0.618;
   gda_140[160] = 2.24;
   gsa_144[160] = gs_176;
   gda_132[161] = 0.786;
   gda_136[161] = 0.707;
   gda_140[161] = 1.618;
   gsa_144[161] = gs_176;
   gda_132[162] = 0.786;
   gda_136[162] = 0.707;
   gda_140[162] = 2.0;
   gsa_144[162] = gs_176;
   gda_132[163] = 0.786;
   gda_136[163] = 0.707;
   gda_140[163] = 2.24;
   gsa_144[163] = gs_176;
   gda_132[164] = 0.786;
   gda_136[164] = 0.786;
   gda_140[164] = 1.618;
   gsa_144[164] = gs_176;
   gda_132[165] = 0.786;
   gda_136[165] = 0.786;
   gda_140[165] = 2.0;
   gsa_144[165] = gs_176;
   gda_132[166] = 0.786;
   gda_136[166] = 0.786;
   gda_140[166] = 2.24;
   gsa_144[166] = gs_176;
   gda_132[167] = 0.786;
   gda_136[167] = 0.886;
   gda_140[167] = 1.618;
   gsa_144[167] = gs_176;
   gda_132[168] = 0.786;
   gda_136[168] = 0.886;
   gda_140[168] = 2.0;
   gsa_144[168] = gs_176;
   gda_132[169] = 0.786;
   gda_136[169] = 0.886;
   gda_140[169] = 2.24;
   gsa_144[169] = gs_176;
}

int Check(double ad_0, double ad_8, double ad_16) {
   bool li_ret_24 = FALSE;
   int li_28 = 999999;
   for (int l_index_32 = 0; l_index_32 < 170; l_index_32++) {
      gda_148[l_index_32] = 0;
      gda_148[l_index_32] = MathSqrt(MathPow(ad_0 - gda_132[l_index_32], 2) + MathPow(ad_8 - gda_136[l_index_32], 2) + MathPow(ad_16 - gda_140[l_index_32], 2));
      if (gda_148[l_index_32] < li_28) {
         li_28 = gda_148[l_index_32];
         li_ret_24 = l_index_32;
      }
   }
   return (li_ret_24);
}